/*=============================================================================
  Copyright (c) 2011-2017 Bolero MURAKAMI
  https://github.com/bolero-MURAKAMI/Sprout

  Distributed under the Boost Software License, Version 1.0. (See accompanying
  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
=============================================================================*/
#ifndef SPROUT_ALGORITHM_CXX14_HPP
#define SPROUT_ALGORITHM_CXX14_HPP

#include <sprout/config.hpp>
#include <sprout/algorithm/cxx14/for_each.hpp>
#include <sprout/algorithm/cxx14/copy.hpp>
#include <sprout/algorithm/cxx14/copy_n.hpp>
#include <sprout/algorithm/cxx14/copy_if.hpp>
#include <sprout/algorithm/cxx14/copy_backward.hpp>
#include <sprout/algorithm/cxx14/move.hpp>
#include <sprout/algorithm/cxx14/move_backward.hpp>
#include <sprout/algorithm/cxx14/swap_ranges.hpp>
#include <sprout/algorithm/cxx14/iter_swap.hpp>
#include <sprout/algorithm/cxx14/transform.hpp>
#include <sprout/algorithm/cxx14/replace.hpp>
#include <sprout/algorithm/cxx14/replace_if.hpp>
#include <sprout/algorithm/cxx14/replace_copy.hpp>
#include <sprout/algorithm/cxx14/replace_copy_if.hpp>
#include <sprout/algorithm/cxx14/fill.hpp>
#include <sprout/algorithm/cxx14/fill_n.hpp>
#include <sprout/algorithm/cxx14/generate.hpp>
#include <sprout/algorithm/cxx14/generate_n.hpp>
#include <sprout/algorithm/cxx14/remove.hpp>
#include <sprout/algorithm/cxx14/remove_if.hpp>
#include <sprout/algorithm/cxx14/remove_copy.hpp>
#include <sprout/algorithm/cxx14/remove_copy_if.hpp>
#include <sprout/algorithm/cxx14/unique.hpp>
#include <sprout/algorithm/cxx14/unique_copy.hpp>
#include <sprout/algorithm/cxx14/reverse.hpp>
#include <sprout/algorithm/cxx14/reverse_copy.hpp>
#include <sprout/algorithm/cxx14/rotate.hpp>
#include <sprout/algorithm/cxx14/rotate_copy.hpp>
#include <sprout/algorithm/cxx14/random_shuffle.hpp>
#include <sprout/algorithm/cxx14/shuffle.hpp>
#include <sprout/algorithm/cxx14/partition.hpp>
#include <sprout/algorithm/cxx14/stable_partition.hpp>
#include <sprout/algorithm/cxx14/partition_copy.hpp>
#include <sprout/algorithm/cxx14/sort.hpp>
#include <sprout/algorithm/cxx14/stable_sort.hpp>
#include <sprout/algorithm/cxx14/partial_sort.hpp>
#include <sprout/algorithm/cxx14/partial_sort_copy.hpp>
#include <sprout/algorithm/cxx14/nth_element.hpp>
#include <sprout/algorithm/cxx14/merge.hpp>
#include <sprout/algorithm/cxx14/inplace_merge.hpp>
#include <sprout/algorithm/cxx14/set_union.hpp>
#include <sprout/algorithm/cxx14/set_intersection.hpp>
#include <sprout/algorithm/cxx14/set_difference.hpp>
#include <sprout/algorithm/cxx14/set_symmetric_difference.hpp>
#include <sprout/algorithm/cxx14/push_heap.hpp>
#include <sprout/algorithm/cxx14/pop_heap.hpp>
#include <sprout/algorithm/cxx14/make_heap.hpp>
#include <sprout/algorithm/cxx14/sort_heap.hpp>
#include <sprout/algorithm/cxx14/next_permutation.hpp>
#include <sprout/algorithm/cxx14/prev_permutation.hpp>
#include <sprout/algorithm/cxx14/sample.hpp>
#include <sprout/algorithm/cxx14/copy_while.hpp>
#include <sprout/algorithm/cxx14/copy_until.hpp>
#include <sprout/algorithm/cxx14/clamp_range.hpp>
#include <sprout/algorithm/cxx14/gather.hpp>
#include <sprout/algorithm/cxx14/random_swap.hpp>
#include <sprout/algorithm/cxx14/bogo_sort.hpp>
#include <sprout/algorithm/cxx14/bozo_sort.hpp>

#endif	// #ifndef SPROUT_ALGORITHM_CXX14_HPP
