/*=============================================================================
  Copyright (c) 2011-2017 Bolero MURAKAMI
  https://github.com/bolero-MURAKAMI/Sprout

  Distributed under the Boost Software License, Version 1.0. (See accompanying
  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
=============================================================================*/
#ifndef SPROUT_RANGE_ALGORITHM_CXX14_PREV_PERMUTATION_HPP
#define SPROUT_RANGE_ALGORITHM_CXX14_PREV_PERMUTATION_HPP

#include <sprout/config.hpp>
#include <sprout/container/functions.hpp>
#include <sprout/utility/forward.hpp>
#include <sprout/algorithm/cxx14/prev_permutation.hpp>

namespace sprout {
	namespace range {
		//
		// prev_permutation
		//
		template<typename BidirectionalRange, typename Compare>
		inline SPROUT_CXX14_CONSTEXPR bool
		prev_permutation(BidirectionalRange&& rng, Compare comp) {
			return sprout::prev_permutation(sprout::begin(SPROUT_FORWARD(BidirectionalRange, rng)), sprout::end(SPROUT_FORWARD(BidirectionalRange, rng)), comp);
		}

		template<typename BidirectionalRange>
		inline SPROUT_CXX14_CONSTEXPR bool
		prev_permutation(BidirectionalRange&& rng) {
			return sprout::prev_permutation(sprout::begin(SPROUT_FORWARD(BidirectionalRange, rng)), sprout::end(SPROUT_FORWARD(BidirectionalRange, rng)));
		}
	}	// namespace range
}	// namespace sprout

#endif	// #ifndef SPROUT_RANGE_ALGORITHM_CXX14_PREV_PERMUTATION_HPP
